  'Debug.Str(string(""))
  'Debug.Str(string("",13))
  'Debug.Dec()
  'Debug.Rx()
  'Debug.Tx()

CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000

  'defining constants makes code selfexplaining
  'see line with Debug.Start(.... 
  DebugTx_Pin = 30
  DebugRx_Pin = 31
  Baudrate    = 115200
  FDX_Mode    = 0  

  Prop1Rx_Pin = 6
  Prop1Tx_Pin = 7

  'Rx and Tx have to be connected cross-over 
  Prop2Rx_Pin = Prop1Tx_Pin  
  Prop2Tx_Pin = Prop1Rx_Pin

  Tx_LED_Pin = 16
  Rx_LED_Pin = 22
  
  Baud    = 9600
  
    
VAR
  byte MyChar
  
OBJ
  Debug   : "FullDuplexSerialPlus"
  Serial  : "FullDuplexSerialPlus"
  
PUB Main
  StartSerialDebugging

  Debug.Str(string("This is the send&receive-code ",13))
  Debug.Str(string("start FullDuplexSerial",13))
  Debug.Str(string("This Prop sends on Pin "))
  Debug.Dec(Prop1Tx_Pin)
  Debug.Str(string("This Prop receives on Pin "))
  Debug.Dec(Prop1Rx_Pin)
  Debug.Str(string(" with "))
  Debug.Dec(Baud)
  Debug.Str(string(" baud",13))
  
  Debug.Tx(13)

  Serial.Start(Prop1Rx_Pin, Prop1Tx_Pin, 0, Baud)
  
  Debug.Str(string("now this code starts sending character 'A' every second ",13))
  Debug.Str(string("and waits then for the byte to be received",13))
  Debug.Str(string("connect DIRECTLY PIN ",13))
  Debug.Dec(Prop1Tx_Pin)
  Debug.Str(string(" with PIN "))
  Debug.Dec(Prop1Rx_Pin)
  Debug.Str(string(" to create a closed loop ",13))
  
  Debug.Str(string("each time a byte is send the LED No "))
  Debug.Dec(Tx_LED_Pin)
  Debug.Str(string(" does a short flash",13))

  Debug.Str(string("each time a byte is received the LED No "))
  Debug.Dec(Rx_LED_Pin)
  Debug.Str(string(" does a short flash",13))

  DirA[Rx_LED_Pin] := 1
  DirA[Tx_LED_Pin] := 1
  OutA[Rx_LED_Pin] := 0
  OutA[Tx_LED_Pin] := 0
    
  repeat
    Serial.Tx("A")
    OutA[Tx_LED_Pin] := 1           'LED On
    WaitCnt(ClkFreq / 5 + cnt)  'wait 0,1 seconds
    OutA[Tx_LED_Pin] := 0           'LED Off
    WaitCnt(ClkFreq / 2 + cnt)
    
    MyChar := Serial.Rx

    OutA[Rx_LED_Pin] := 1           'LED On
    WaitCnt(ClkFreq / 10 + cnt)  'wait 0,1 seconds
    OutA[Rx_LED_Pin] := 0           'LED Off
    
    Debug.Str(string("received a byte ASCII-code "))
    Debug.Dec(MyChar)
    Debug.Str(string("   as char "))
    Debug.Tx(MyChar)
    
    Debug.Tx(13)


Pub StartSerialDebugging
  Debug.Start(DebugRx_Pin,DebugTx_Pin,FDX_Mode,Baudrate)

  Debug.Str(string("FullDuplexSerialPlus-Driver started with ",13))
  Debug.Str(string("Start(DebugRx_Pin="))
  Debug.Dec(DebugRx_Pin)
  Debug.Str(string(",DebugTx_Pin="))
  Debug.Dec(DebugTx_Pin)
  Debug.Str(string(",FDX_Mode="))
  Debug.Dec(FDX_Mode)
  Debug.Str(string(",Baudrate="))
  Debug.Dec(Baudrate)
  Debug.Str(string(13,13))



  